Add Kconfig files for the northbridge. Currently we only need this for the geodelx, 
so we can select nrv2b decompression. 

This has been tested in build and behaves as we want it to: nrv decompression 
is enabled and the code compiled in. 

Signed-off-by: Ronald G. Minnich <rminnich@gmail.com>

Index: Kconfig
===================================================================
--- Kconfig	(revision 560)
+++ Kconfig	(working copy)
@@ -63,6 +63,7 @@
 endmenu
 
 source mainboard/Kconfig
+source northbridge/Kconfig
 source arch/x86/Kconfig
 source lib/Kconfig
 source device/Kconfig
Index: northbridge/Kconfig
===================================================================
--- northbridge/Kconfig	(revision 0)
+++ northbridge/Kconfig	(revision 0)
@@ -0,0 +1,24 @@
+##
+## This file is part of the LinuxBIOS project.
+##
+## Copyright (C) 2006 Segher Boessenkool <segher@kernel.crashing.org>
+## Copyright (C) 2006-2007 coresystems GmbH
+## (Written by Stefan Reinauer <stepan@coresystems.de> for coresystems GmbH)
+## Copyright (C) 2007 Uwe Hermann <uwe@hermann-uwe.de>
+##
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; version 2 of the License.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+##
+
+source "northbridge/amd/Kconfig"
+
Index: northbridge/amd/Kconfig
===================================================================
--- northbridge/amd/Kconfig	(revision 0)
+++ northbridge/amd/Kconfig	(revision 0)
@@ -0,0 +1,24 @@
+##
+## This file is part of the LinuxBIOS project.
+##
+## Copyright (C) 2006 Segher Boessenkool <segher@kernel.crashing.org>
+## Copyright (C) 2006-2007 coresystems GmbH
+## (Written by Stefan Reinauer <stepan@coresystems.de> for coresystems GmbH)
+## Copyright (C) 2007 Uwe Hermann <uwe@hermann-uwe.de>
+##
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; version 2 of the License.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+##
+
+source "northbridge/amd/geodelx/Kconfig"
+
Index: northbridge/amd/geodelx/Kconfig
===================================================================
--- northbridge/amd/geodelx/Kconfig	(revision 0)
+++ northbridge/amd/geodelx/Kconfig	(revision 0)
@@ -0,0 +1,23 @@
+##
+## This file is part of the LinuxBIOS project.
+##
+## Copyright (C) 2006 Segher Boessenkool <segher@kernel.crashing.org>
+## Copyright (C) 2006-2007 coresystems GmbH
+## (Written by Stefan Reinauer <stepan@coresystems.de> for coresystems GmbH)
+## Copyright (C) 2007 Uwe Hermann <uwe@hermann-uwe.de>
+##
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; version 2 of the License.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+##
+
+select COMPRESSION_NRV2B