Index: src/Kconfig
===================================================================
--- src/Kconfig	(Revision 4726)
+++ src/Kconfig	(Arbeitskopie)
@@ -61,6 +61,10 @@
 	int
 	default 36
 
+config AGP_APERTURE_SIZE
+	hex
+	default 0
+
 config XIP_ROM_BASE
 	hex
 	default 0xfffe0000
Index: src/cpu/Kconfig
===================================================================
--- src/cpu/Kconfig	(Revision 4726)
+++ src/cpu/Kconfig	(Arbeitskopie)
@@ -21,6 +21,10 @@
 	hex
 	default 0
 
+config MAX_PHYSICAL_CPUS
+	int
+	default 1
+
 config SMP
 	bool
 	default y if MAX_CPUS != 1
@@ -39,3 +43,10 @@
 	help
 		Set this in socket or model if the CPU has SSE. 
 		If the CPUs for the socket always have MX, set it there. 
+
+config VAR_MTRR_HOLE
+	bool
+	default y
+	help
+		Unset this if you don't want the MTRR code to use
+		subtractive MTRRs
Index: src/cpu/x86/Kconfig
===================================================================
--- src/cpu/x86/Kconfig	(Revision 4726)
+++ src/cpu/x86/Kconfig	(Arbeitskopie)
@@ -6,6 +6,14 @@
 	bool
 	default n
 
+config UDELAY_IO
+	bool
+	default n
+
+config UDELAY_LAPIC
+	bool
+	default n
+
 config UDELAY_TSC
 	bool
 	default n
Index: src/cpu/intel/model_1067x/Kconfig
===================================================================
--- src/cpu/intel/model_1067x/Kconfig	(Revision 4726)
+++ src/cpu/intel/model_1067x/Kconfig	(Arbeitskopie)
@@ -1,5 +1,5 @@
 config CPU_INTEL_CORE2
 	bool
-	default y
+	default n
 	select SMP
 	select HAVE_MOVNTI
Index: src/mainboard/supermicro/h8dme/Kconfig
===================================================================
--- src/mainboard/supermicro/h8dme/Kconfig	(Revision 4726)
+++ src/mainboard/supermicro/h8dme/Kconfig	(Arbeitskopie)
@@ -116,3 +116,7 @@
 	default y
 	depends on BOARD_SUPERMICRO_H8DME
 
+config IRQ_SLOT_COUNT
+	int
+	default 11
+	depends on BOARD_SUPERMICRO_H8DME
Index: src/mainboard/kontron/986lcd-m/Kconfig
===================================================================
--- src/mainboard/kontron/986lcd-m/Kconfig	(Revision 4726)
+++ src/mainboard/kontron/986lcd-m/Kconfig	(Arbeitskopie)
@@ -45,3 +45,13 @@
 	hex
 	default 0xf0000000
 	depends on BOARD_KONTRON_986LCD_M
+
+config IRQ_SLOT_COUNT
+	int
+	default 18
+	depends on BOARD_KONTRON_986LCD_M
+
+config MAX_PHYSICAL_CPUS
+	int
+	default 2
+	depends on BOARD_KONTRON_986LCD_M
Index: src/mainboard/gigabyte/m57sli/Kconfig
===================================================================
--- src/mainboard/gigabyte/m57sli/Kconfig	(Revision 4726)
+++ src/mainboard/gigabyte/m57sli/Kconfig	(Arbeitskopie)
@@ -18,7 +18,6 @@
 	select SB_HT_CHAIN_UNITID_OFFSET_ONLY
 	select HAVE_ACPI_TABLES
 	select K8_REV_F_SUPPORT
-	select HAVE_FANCTL
  
 config MAINBOARD_DIR
 	string
@@ -144,3 +143,14 @@
 	hex
 	default 0x2b80
 	depends on BOARD_GIGABYTE_M57SLI
+
+config IRQ_SLOT_COUNT
+	int
+	default 11
+	depends on BOARD_GIGABYTE_M57SLI
+
+# not globally defined yet, so can't "select" this
+config HAVE_FANCTL
+	bool
+	default y
+	depends on BOARD_GIGABYTE_M57SLI
Index: src/mainboard/emulation/qemu-x86/Kconfig
===================================================================
--- src/mainboard/emulation/qemu-x86/Kconfig	(Revision 4726)
+++ src/mainboard/emulation/qemu-x86/Kconfig	(Arbeitskopie)
@@ -15,3 +15,8 @@
 	string
 	default "QEMU-x86"
 	depends on BOARD_EMULATION_QEMU_X86
+
+config IRQ_SLOT_COUNT
+	int
+	default 6
+	depends on BOARD_EMULATION_QEMU_X86
Index: src/mainboard/amd/serengeti_cheetah/Kconfig
===================================================================
--- src/mainboard/amd/serengeti_cheetah/Kconfig	(Revision 4726)
+++ src/mainboard/amd/serengeti_cheetah/Kconfig	(Arbeitskopie)
@@ -147,3 +147,7 @@
 	default y
 	depends on BOARD_AMD_SERENGETI_CHEETAH
 
+config IRQ_SLOT_COUNT
+	int
+	default 11
+	depends on BOARD_AMD_SERENGETI_CHEETAH
Index: src/mainboard/tyan/s2850/Kconfig
===================================================================
--- src/mainboard/tyan/s2850/Kconfig	(Revision 4726)
+++ src/mainboard/tyan/s2850/Kconfig	(Arbeitskopie)
@@ -53,3 +53,8 @@
 	bool
 	default n
 	depends on BOARD_TYAN_S2850
+
+config IRQ_SLOT_COUNT
+	int
+	default 12
+	depends on BOARD_TYAN_S2850
Index: src/mainboard/tyan/s2881/Kconfig
===================================================================
--- src/mainboard/tyan/s2881/Kconfig	(Revision 4726)
+++ src/mainboard/tyan/s2881/Kconfig	(Arbeitskopie)
@@ -125,3 +125,7 @@
 	default n
 	depends on BOARD_TYAN_S2881
 
+config IRQ_SLOT_COUNT
+	int
+	default 9
+	depends on BOARD_TYAN_S2881
Index: src/mainboard/tyan/s1846/Kconfig
===================================================================
--- src/mainboard/tyan/s1846/Kconfig	(Revision 4726)
+++ src/mainboard/tyan/s1846/Kconfig	(Arbeitskopie)
@@ -42,3 +42,8 @@
 	default n
 	depends on BOARD_TYAN_S1846
 
+#Override manually, as in Config.lb (FIXME)
+config IRQ_SLOT_COUNT
+	int
+	default 0
+	depends on BOARD_TYAN_S1846
Index: src/mainboard/tyan/s2891/Kconfig
===================================================================
--- src/mainboard/tyan/s2891/Kconfig	(Revision 4726)
+++ src/mainboard/tyan/s2891/Kconfig	(Arbeitskopie)
@@ -125,3 +125,7 @@
 	default y
 	depends on BOARD_TYAN_S2891
 
+config IRQ_SLOT_COUNT
+	int
+	default 11
+	depends on BOARD_TYAN_S2891
Index: src/mainboard/tyan/s2892/Kconfig
===================================================================
--- src/mainboard/tyan/s2892/Kconfig	(Revision 4726)
+++ src/mainboard/tyan/s2892/Kconfig	(Arbeitskopie)
@@ -125,3 +125,7 @@
 	default y
 	depends on BOARD_TYAN_S2892
 
+config IRQ_SLOT_COUNT
+	int
+	default 11
+	depends on BOARD_TYAN_S2892
Index: src/mainboard/tyan/s2875/Kconfig
===================================================================
--- src/mainboard/tyan/s2875/Kconfig	(Revision 4726)
+++ src/mainboard/tyan/s2875/Kconfig	(Arbeitskopie)
@@ -59,3 +59,8 @@
 	bool
 	default n
 	depends on BOARD_TYAN_S2875
+
+config IRQ_SLOT_COUNT
+	int
+	default 13
+	depends on BOARD_TYAN_S2875
Index: src/mainboard/tyan/s2895/Kconfig
===================================================================
--- src/mainboard/tyan/s2895/Kconfig	(Revision 4726)
+++ src/mainboard/tyan/s2895/Kconfig	(Arbeitskopie)
@@ -125,3 +125,7 @@
 	default y
 	depends on BOARD_TYAN_S2895
 
+config IRQ_SLOT_COUNT
+	int
+	default 11
+	depends on BOARD_TYAN_S2895
Index: src/mainboard/via/epia-n/Kconfig
===================================================================
--- src/mainboard/via/epia-n/Kconfig	(Revision 4726)
+++ src/mainboard/via/epia-n/Kconfig	(Arbeitskopie)
@@ -36,3 +36,13 @@
 	hex
 	default 0x4000
 	depends on BOARD_VIA_EPIA_N
+
+config IRQ_SLOT_COUNT
+	int
+	default 7
+	depends on BOARD_VIA_EPIA_N
+
+config EPIA_VT8237R_INIT
+	bool
+	default y
+	depends on BOARD_VIA_EPIA_N
Index: src/mainboard/via/epia/Kconfig
===================================================================
--- src/mainboard/via/epia/Kconfig	(Revision 4726)
+++ src/mainboard/via/epia/Kconfig	(Arbeitskopie)
@@ -31,3 +31,8 @@
 	hex
 	default 0x4000
 	depends on BOARD_VIA_EPIA
+
+config IRQ_SLOT_COUNT
+	int
+	default 5
+	depends on BOARD_VIA_EPIA
Index: src/mainboard/dell/s1850/Kconfig
===================================================================
--- src/mainboard/dell/s1850/Kconfig	(Revision 4726)
+++ src/mainboard/dell/s1850/Kconfig	(Arbeitskopie)
@@ -48,3 +48,7 @@
 	default n
 	depends on BOARD_DELL_S1850
 
+config IRQ_SLOT_COUNT
+	int
+	default 9
+	depends on BOARD_DELL_S1850
Index: src/mainboard/sunw/ultra40/Kconfig
===================================================================
--- src/mainboard/sunw/ultra40/Kconfig	(Revision 4726)
+++ src/mainboard/sunw/ultra40/Kconfig	(Arbeitskopie)
@@ -116,3 +116,7 @@
 	default y
 	depends on BOARD_SUNW_ULTRA40
 
+config IRQ_SLOT_COUNT
+	int
+	default 11
+	depends on BOARD_SUNW_ULTRA40
Index: src/mainboard/intel/eagleheights/Kconfig
===================================================================
--- src/mainboard/intel/eagleheights/Kconfig	(Revision 4726)
+++ src/mainboard/intel/eagleheights/Kconfig	(Arbeitskopie)
@@ -53,3 +53,12 @@
 	default 0xe0000000
 	depends on BOARD_INTEL_EAGLEHEIGHTS
 
+config IRQ_SLOT_COUNT
+	int
+	default 18
+	depends on BOARD_INTEL_EAGLEHEIGHTS
+
+config MAX_PHYSICAL_CPUS
+	int
+	default 2
+	depends on BOARD_INTEL_EAGLEHEIGHTS
Index: src/mainboard/asus/m2v-mx_se/Kconfig
===================================================================
--- src/mainboard/asus/m2v-mx_se/Kconfig	(Revision 4726)
+++ src/mainboard/asus/m2v-mx_se/Kconfig	(Arbeitskopie)
@@ -115,3 +115,8 @@
 	default 0x20
 	depends on BOARD_ASUS_M2V_MX_SE
 
+# FIXME?
+config IRQ_SLOT_COUNT
+	int
+	default 11
+	depends on BOARD_ASUS_M2V_MX_SE
Index: src/console/Kconfig
===================================================================
--- src/console/Kconfig	(Revision 4726)
+++ src/console/Kconfig	(Arbeitskopie)
@@ -24,6 +24,11 @@
 	depends on SERIAL_SET_SPEED
 	default 115200
 
+config TTYS0_LCS
+	int
+	default 3
+	depends on CONSOLE_SERIAL8250
+
 config USBDEBUG_DIRECT
 	bool "USB debug dongle support. Not supported on all chipsets."
 	default n